//+------------------------------------------------------------------+
//|                                                   Stochastic RSI |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     LimeGreen
#property indicator_color2     Red
#property indicator_color3     Gold
#property indicator_color4     DarkSlateGray
#property indicator_width1     2
#property indicator_width2     2
#property indicator_style3     STYLE_DASH
#property indicator_width4     2
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern string TimeFrame                 = "Current time frame";
extern int    RsiPeriod                 = 13;
extern int    Price                     = PRICE_TYPICAL;
extern int    StochasticKPeriod         = 10;
extern int    StochasticSlowing         = 3;
extern int    StochasticSlowingMaMethod = MODE_LWMA;
extern int    StochasticDPeriod         = 3;
extern int    StochasticDMaMethod       = MODE_LWMA;

extern double levelOs                   = 40;
extern double levelOb                   = -40; 
extern string __MaMethods               = "";
extern string __0                       = "SMA";
extern string __1                       = "EMA";
extern string __2                       = "Smoothed MA";
extern string __3                       = "Linear weighted MA";
extern string __4                       = "Triangular MA";
extern string __5                       = "Volume weghted MA";
extern string __6                       = "Sine weighted MA";
extern string __7                       = "EPMA";

extern string note                      = "turn on Alert = true; turn off = false";
extern bool   alertsOn                  = true;
extern bool   alertsOnCurrent           = false;
extern bool   alertsOnOsOb              = true;
extern bool   alertsOnStochSigCross     = false;
extern bool   alertsMessage             = true;
extern bool   alertsSound               = false;
extern bool   alertsEmail               = false;
extern bool   alertsPush                = false;
extern string soundFile                 = "alert2.wav";

//
//
//
//
//

double stoRsiUp[];
double stoRsiDn[];
double stochRsi[];
double stochRsiSignal[];
double rsi[];
double stoch[];
double trend1[];
double trend2[];
double trends[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,stoRsiUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,stoRsiDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,stochRsiSignal);
   SetIndexBuffer(3,stochRsi);
   SetIndexBuffer(4,rsi);
   SetIndexBuffer(5,stoch);
   SetIndexBuffer(6,trend1);
   SetIndexBuffer(7,trend2);
   SetLevelValue(0,levelOs);
   SetLevelValue(1,levelOb);
   SetLevelValue(2,0);

      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      string smooth1    = getAverageName(StochasticSlowingMaMethod);
      string smooth2    = getAverageName(StochasticDMaMethod);
      
      //
      //
      //
      //
      //
      
   IndicatorShortName(timeFrameToString(timeFrame)+"  StochRsi ("+RsiPeriod+","+StochasticKPeriod+","+StochasticSlowing+","+smooth1+","+StochasticDPeriod+","+smooth2+")");
   return(0);
}
int deinit() { return(0);}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { stochRsi[0] = limit+1; return(0); }   
          
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      if (ArrayRange(trends,0)!=Bars)  ArrayResize(trends,Bars);
      for (i=limit, r=Bars-i-1; i>=0; i--, r++)
      {       
          rsi[i]     = iRsi(iMA(NULL,0,1,0,MODE_SMA,Price,i),RsiPeriod,i);
          double min = rsi[ArrayMinimum(rsi,StochasticKPeriod,i)];
          double max = rsi[ArrayMaximum(rsi,StochasticKPeriod,i)];
          stoch[i]   = 0.5; if (min!=max) stoch[i] = 100.0*(rsi[i]-min)/(max-min); 
          stochRsi[i] = iCMAOnArray(stoch   ,stochRsi      ,StochasticSlowing,StochasticSlowingMaMethod,i)-50;
          stochRsiSignal[i] = iCMAOnArray(stochRsi,stochRsiSignal,StochasticDPeriod,StochasticDMaMethod,i);
             stoRsiUp[i] = EMPTY_VALUE;
             stoRsiDn[i] = EMPTY_VALUE; 
             trend1[i]   = trend1[i+1]; 
             trend2[i]   = trend2[i+1]; 
             trends[r]   = trends[r-1];
             
             if (stochRsi[i] <= levelOs && stochRsi[i] > stochRsi[i+1] && stochRsi[i+1] < stochRsi[i+2]) trend1[i] =  1;
             if (stochRsi[i] >= levelOb && stochRsi[i] < stochRsi[i+1] && stochRsi[i+1] > stochRsi[i+2]) trend1[i] = -1;
             if (stochRsi[i] > stochRsiSignal[i])                                                        trend2[i] =  1;
             if (stochRsi[i] < stochRsiSignal[i])                                                        trend2[i] = -1;
             if (stochRsi[i] > 0)                                                                        trends[r] =  1;
             if (stochRsi[i] < 0)                                                                        trends[r] = -1;
             if (trends[r] == 1) stoRsiUp[i] = stochRsi[i];
             if (trends[r] ==-1) stoRsiDn[i] = stochRsi[i];    
        }
        manageAlerts();
      return(0);
      }
      
      //
      //
      //
      //
      //
   
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      if (ArrayRange(trends,0)!=Bars) ArrayResize(trends,Bars);
      for (i=limit, r=Bars-i-1; i>=0; i--, r++)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            stochRsiSignal[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,Price,StochasticKPeriod,StochasticSlowing,StochasticSlowingMaMethod,StochasticDPeriod,StochasticDMaMethod,2,y);
            stochRsi[i]       = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,Price,StochasticKPeriod,StochasticSlowing,StochasticSlowingMaMethod,StochasticDPeriod,StochasticDMaMethod,3,y);
            trend1[i]         = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,Price,StochasticKPeriod,StochasticSlowing,StochasticSlowingMaMethod,StochasticDPeriod,StochasticDMaMethod,6,y);
            trend2[i]         = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,Price,StochasticKPeriod,StochasticSlowing,StochasticSlowingMaMethod,StochasticDPeriod,StochasticDMaMethod,7,y);
            stoRsiUp[i] = EMPTY_VALUE;
            stoRsiDn[i] = EMPTY_VALUE;
            trends[r]   = trends[r-1];
            if (stochRsi[i] > 0)  trends[r] =  1;
            if (stochRsi[i] < 0)  trends[r] = -1;
            if (trends[r] == 1) stoRsiUp[i] = stochRsi[i];
            if (trends[r] ==-1) stoRsiDn[i] = stochRsi[i];    
      }
      manageAlerts();
return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
return(s);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double workRsi[][3];
#define _price  0
#define _change 1
#define _changa 2

//
//
//
//

double iRsi(double price, double period, int shift, int forz=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int    z     = forz*3; 
      int    i     = Bars-shift-1;
      double alpha = 1.0/period; 

   //
   //
   //
   //
   //
   
   workRsi[i][_price+z] = price;
   if (i<period)
      {
         int k; double sum = 0; for (k=0; k<period && (i-k-1)>=0; k++) sum += MathAbs(workRsi[i-k][_price+z]-workRsi[i-k-1][_price+z]);
            workRsi[i][_change+z] = (workRsi[i][_price+z]-workRsi[0][_price+z])/MathMax(k,1);
            workRsi[i][_changa+z] =                                         sum/MathMax(k,1);
      }
   else
      {
         double change = workRsi[i][_price+z]-workRsi[i-1][_price+z];
                         workRsi[i][_change+z] = workRsi[i-1][_change+z] + alpha*(        change  - workRsi[i-1][_change+z]);
                         workRsi[i][_changa+z] = workRsi[i-1][_changa+z] + alpha*(MathAbs(change) - workRsi[i-1][_changa+z]);
      }
   if (workRsi[i][_changa+z] != 0)
         return(50.0*(workRsi[i][_change+z]/workRsi[i][_changa+z]+1));
   else  return(0);
}

//
//
//
//
//

double iCMAOnArray(double& source[], double& result[], int period, int method, int i)
{
   switch(method)
   {
      case 0: return(iSmaOnArray(source,period,i));
      case 1: return(iEmaOnArray(source,result,period,i));
      case 2: return(iSmmaOnArray(source,result,period,i));
      case 3: return(iLwmaOnArray(source,period,i));
      case 4: return(iTmaOnArray(source,period,i));
      case 5: return(iSineWMAOnArray(source,period,i));
      case 6: return(iVolumeWMAOnArray(source,period,i));
      case 7: return(iEPMAOnArray(source,period,i));
   }
   return(EMPTY_VALUE);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iSmaOnArray(double& array[], double period, int i)
{
   double sum = 0; 
   for(int k=0; k<period && (i+k)<Bars; k++) sum += array[i+k];  
   if (k!=0)
         return(sum/k);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iEmaOnArray(double& source[], double& result[], double period, int i)
{
   double alpha = 2.0 / (1.0+period);
          result[i] = result[i+1]+alpha*(source[i]-result[i+1]);
   return(result[i]);
}
//
//
//
//
//

double iSmmaOnArray(double& source[], double& result[], double period, int i)
{
   if (i>=(Bars-period))
   {
      double sum = 0; 
         for(int k=0; k<period && (i+k)<Bars; k++) sum += source[i+k];  
         if (k!=0)
               result[i] = sum/k;
         else  result[i] = EMPTY_VALUE;
   }      
   else   result[i] = (result[i+1]*(period-1)+source[i])/period;
   return(result[i]);
}

//
//
//
//
//

double iLwmaOnArray(double& array[], double period, int i)
{
   double sum  = 0;
   double sumw = 0;

   for(int k=0; k<period && (i+k)<Bars; k++)
   {
      double weight = period-k;
             sumw  += weight;
             sum   += weight*array[i+k];  
   }             
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iTmaOnArray(double& array[], double period, int i)
{
   double half = (period+1.0)/2.0;
   double sum  = 0;
   double sumw = 0;

   for(int k=0; k<period && (i+k)<Bars; k++)
   {
      double weight = k+1; if (weight > half) weight = period-k;
             sumw  += weight;
             sum   += weight*array[i+k];  
   }             
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

#define Pi 3.14159265358979323846
double iSineWMAOnArray(double& array[], int period, int i)
{
   double sum  = 0;
   double sumw = 0;
  
   for(int k=0; k<period && (i+k)<Bars; k++)
   { 
      double weight = MathSin(Pi*(k+1)/(period+1));
             sumw  += weight;
             sum   += weight*array[i+k]; 
   }
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iVolumeWMAOnArray(double& array[], int period, int i)
{
   double sum  = 0;
   double sumw = 0;
  
   for(int k=0; k<period && (i+k)<Bars; k++)
   { 
      double weight = Volume[i+k];
             sumw  += weight;
             sum   += weight*array[i+k]; 
   }
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iEPMAOnArray(double& array[], int period, int i)
{
   double weight = 2.0*period-1.0;
   double sum    = 0;
   double sumw   = 0;
  
   for(int k=0; k<period && (i+k)<Bars; k++)
   { 
       sumw   += weight;
       sum    += weight*array[i+k]; 
       weight -= 3;
   }
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string methodNames[] = {"SMA","EMA","SMMA","LWMA","TriMA","SWMA","VWMA","EPMA"};
string getAverageName(int& method)
{
   method=MathMax(MathMin(method,7),0); return(methodNames[method]);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnOsOb && trend1[whichBar] != trend1[whichBar+1])
         {
            if (trend1[whichBar] ==  1) doAlert(time1,mess1,whichBar," StochRsi leaving oversold level up");
            if (trend1[whichBar] == -1) doAlert(time1,mess1,whichBar," StochRsi leaving oversold level down");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnStochSigCross && trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend2[whichBar] ==  1) doAlert(time2,mess2,whichBar," StochRsi crossed signal up");
            if (trend2[whichBar] == -1) doAlert(time2,mess2,whichBar," StochRsi crossed signal down");
         }            
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  Symbol()+" "+timeFrameToString(timeFrame)+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," StochRsi "),message);
             if (alertsPush)    SendNotification(StringConcatenate(Symbol(), Period() ," StochRsi " +" "+message));
             if (alertsSound)   PlaySound("alert2.wav");
      }
}


